<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des types d'organismes</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">
          Nombre total de type d'organismes : {{ typesOrganismes.length }}
        </h3>
        <div class="column is-narrow">
          <nuxt-link
            :to="{ name: 'profil-dashboard-types-organismes-creer', params: { profil: 'admin' } }"
            tag="button"
            class="is-primary button"
          >
            <b-icon icon="plus" />&nbsp;&nbsp;Créer un type d'organisme
          </nuxt-link>
        </div>
      </div>
      <mt-list v-slot="{ item: typeOrganisme }" :list="typesOrganismes">
        <mt-list-item>
          <div class="columns is-vcentered">
            <nuxt-link
              :to="{
                name: 'profil-dashboard-types-organismes-id-editer',
                params: { profil: 'admin', id: typeOrganisme.id },
              }"
              class="columns column mt-marginless-bottom"
            >
              <div class="column">
                {{ typeOrganisme.code }}
              </div>
              <div class="column">
                {{ typeOrganisme.libelle }}
              </div>
              <div class="column">
                {{ typeOrganisme.ordre }}
              </div>
            </nuxt-link>
            <div class="column is-narrow">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(typeOrganisme)"
                >Supprimer</b-button
              >
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerTypeOrganisme(monTypeOrganisme)">
        Êtes-vous certain(e) de vouloir supprimer le type d'organisme ?
      </mt-modal-action>
    </div>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  async asyncData({ $api }) {
    const typesOrganismes = await $api.typesOrganismes.all();
    return {
      typesOrganismes,
      ouvertDelete: false,
      monTypeOrganisme: null,
    };
  },
  methods: {
    confirmeSupprimer(typeOrganisme) {
      this.ouvertDelete = true;
      this.monTypeOrganisme = typeOrganisme;
    },
    async supprimerTypeOrganisme(typeOrganisme) {
      try {
        await this.$api.typesOrganismes.delete(typeOrganisme.id);
        this.typesOrganismes = await this.$api.typesOrganismes.all();
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.mt-marginless-bottom {
  margin-bottom: 0;
}

/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
</style>
